/*
* Welcome to your app's main JavaScript file!
*
* We recommend including the built version of this JavaScript file
* (and its CSS file) in your base layout (base.html.twig).
*/

// any CSS you import will output into a single css file (app.css in this case)

// start the Stimulus application
//import './bootstrap';

import 'tui-calendar';

var Calendar = require('tui-calendar'); /* CommonJS */

//console.log(calendar)


$(document).ready(function () {
  var calendar = new Calendar('#calendar', {
    defaultView: 'week',
    taskView: false,
    useCreationPopup: true,
    useDetailPopup: true
  });

  var scheduleIds = []
  var currentSchedule = 1

  function sendCalendarData() {
    calendar.getSchedule()
    scheduleIds.forEach(function(id){
      var schedule = calendar.getSchedule(id, '1');
      console.log(schedule)
    })

    $.ajax({
      type: "POST",
      url: "/calendar/send",
      data: calendar._controller.schedules.items,
      success: function (data) { console.log(data) },
      dataType: "application/json"
    });
  }

  calendar.on('beforeCreateSchedule', function (event) {
    var scheduleData = event
    // var calendarId = '1';
    var schedule = {
      id: String(currentSchedule),
      calendarId: '1',
      title: scheduleData.title,
      isAllDay: scheduleData.isAllDay,
      start: scheduleData.start,
      end: scheduleData.end,
      category: scheduleData.isAllDay ? 'allday' : 'time',
      dueDateClass: '',
      color: calendar.color,
      bgColor: calendar.bgColor,
      dragBgColor: calendar.bgColor,
      borderColor: calendar.borderColor,
      location: scheduleData.location,
      isPrivate: scheduleData.isPrivate,
      state: scheduleData.state
    };

    scheduleIds[scheduleIds.length] = currentSchedule;
    currentSchedule++;

    sendCalendarData();

    calendar.createSchedules([schedule]);
  });

  prevBtn.addEventListener("click", e => {
    calendar.prev();
  });
  nextBtn.addEventListener("click", e => {
    calendar.next();
    sendCalendarData();
  });
  calendar.createSchedules([
    {
      id: '1',
      calendarId: '1',
      title: 'my schedule',
      category: 'time',
      dueDateClass: '',
      start: '2022-02-10T22:30:00+09:00',
      end: '2022-02-11T02:30:00+09:00'
    },
    {
      id: '2',
      calendarId: '1',
      title: 'second schedule',
      category: 'time',
      dueDateClass: '',
      start: '2022-02-11T17:30:00+09:00',
      end: '2022-02-12T17:31:00+09:00',
      isReadOnly: true    // schedule is read-only
    }
  ]);
});
